import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:pia_framework_base/Form/PIA_DropDownMenu.dart';
import 'package:pia_framework_base/Lang/PIA_Lang.dart';

const  Map<String, String> _PIA_TextEdit_error_empty = {'1': 'Must fill in ', '2': '必須填寫'};
const  Map<String, String> _PIA_TextEdit_error_email = {'1': 'Enter Valid Email ', '2': '電郵地址不正確'};
const  Map<String, String> _PIA_TextEdit_error_password = {'1': 'Must be 8-16 characters', '2': '必需為 8 - 16 個字元'};

class PIA_Form
{   static const border_line = 1;
    static const border_round = 2;
    static const Type_text = TextInputType.text;
    static const Type_number = TextInputType.number;
    static const Type_phone = TextInputType.phone;
    static const Type_email = TextInputType.emailAddress;
    static const  _padding = 14.0;

Map<String,TextEditingController> _Controller  = Map<String,TextEditingController>();

     var _border_type;
     var _focus_border_type;
     var  _decoration;
     var _text_color;
     double round = 0;

     TextStyle _textStyle;

     final GlobalKey<FormState> _formKey = GlobalKey<FormState>();

     PIA_Form(this._textStyle,this._text_color, double round) {
       this.round = round;

       if (round  == 0) {
         _border_type =  UnderlineInputBorder(
           borderSide: BorderSide(color: _text_color));

         _focus_border_type =  UnderlineInputBorder(
           borderSide: BorderSide(color: _text_color));

       }
       else {
         _border_type = OutlineInputBorder(
           borderRadius: BorderRadius.circular(round),
           borderSide: BorderSide(color: _text_color),
         );

         _focus_border_type = OutlineInputBorder(
           borderRadius: BorderRadius.circular(round),
           borderSide: BorderSide(color: _text_color),
         );


         _decoration = new BoxDecoration(
         border: new Border.all(width: 1.0, color:_text_color),
         borderRadius: new BorderRadius.all(new Radius.circular(round)));
       }
     }

    GlobalKey<FormState> FormKey() => _formKey;
    bool isValid() => _formKey.currentState.validate();


    String get(String key)
     {   return _Controller[key].text; }

Widget switch_ios_button(String key,String textname,bool checkon, Color main_color)
{  _Controller[key] = new TextEditingController(text: checkon? "1" : "0");
return
  Padding(
    padding: const EdgeInsets.only(bottom: _padding),
    child: Column(
      children: <Widget>[
        Container(
          padding: EdgeInsets.only(left:15,top:5,bottom: 5,right: 10),
          decoration: _decoration,
          child:
          Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Text(textname, style:TextStyle(color: _text_color,fontSize: _textStyle.fontSize)),
                SwitchStateWidget(controller:_Controller[key],color:main_color,checkon:checkon),
              ]),
        ),
        (_decoration == null) ? Container(color:_text_color,height: 1,): SizedBox(height: 0)
      ],
    ),
  );
}


 Widget checkbox(String key,String textname,bool checkon,Color main_color)
      {  _Controller[key] = new TextEditingController(text: checkon? "1" : "0");
    return
      Padding(
        padding: const EdgeInsets.only(bottom:_padding),
        child: Column(
        children: <Widget>[
          Container(
            padding: EdgeInsets.only(left:15,top:0,bottom: 0,right: 10),
            decoration: _decoration,
            child:
            Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: <Widget>[
                  Text(textname, style:TextStyle(color: _text_color,fontSize: _textStyle.fontSize)),
                  CheckBoxStateWidget(controller:_Controller[key],color:main_color,checkon:checkon),
                ]),
        ),
        (_decoration == null) ? Container(color:_text_color,height: 1,): SizedBox(height: 0)
    ],
  ),
      );
 }

Widget datepicker(String key,String textname,String value)
{  DateTime selectedDate = DateTime.now();

   String today = "${selectedDate.year}-" + ((selectedDate.month<10) ? "0" : "") + "${selectedDate.month}-" + ((selectedDate.day<10) ? "0" : "")  + "${selectedDate.day}";
  _Controller[key] = new TextEditingController(text: value.isNotEmpty ? value : today);

  return
  Padding(
    padding: const EdgeInsets.only(bottom:_padding),
    child: Column(
      children: <Widget>[
        Container(
          padding: EdgeInsets.only(left:15,top:0,bottom: 0,right: 10),
          decoration: _decoration,
          child:
          Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Text(textname, style:TextStyle(color: _text_color,fontSize: _textStyle.fontSize)),
                DatePickerWidget(controller: _Controller[key], date_text:( value.isNotEmpty ? value : today) , text_color: _textStyle.color,),
              ]),
        ),
        (_decoration == null) ? Container(color:_text_color,height: 1,): SizedBox(height: 0)
      ],
    ),
  );
}


 Widget DropDownMenu(String key,String textname,int default_index,List<String> item)
    {  _Controller[key] = new TextEditingController();
      return
         Padding(
           padding: const EdgeInsets.only(bottom:_padding),
           child: Column(
             children: <Widget>[
               Container(
                padding: EdgeInsets.only(left:15,top:0,bottom: 0,right: 10),
                decoration: _decoration,
                 child:
                    Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: <Widget>[
                       Text(textname, style:TextStyle(color: _text_color,fontSize: _textStyle.fontSize)),
                       PIA_DropDownMenu(
                          item: item,
                          select_id: default_index,
                          textcontroller: _Controller[key],
                       )
                    ]),
                 ),
               (_decoration == null) ? Container(color:_text_color,height: 1,): SizedBox(height: 0)
             ],
           ),
         );
    }

    Widget text(String key, String textname,String initvalue, int max_size, bool mustfill, TextAlign align,TextInputType type, IconData icon ,String placeholder,String suffixText)
     {
       _Controller[key] = new TextEditingController(text:initvalue);
       return Padding(
           padding: EdgeInsets.only(bottom: _padding),
           child: TextFormField(
               textAlign: align,
               controller: _Controller[key],
               maxLength: max_size,
               style: _textStyle,
               decoration: InputDecoration(
               contentPadding: EdgeInsets.only(left:15,top:20,bottom: (this.round == 0) ? 3 : 10 ,right: 15),
                 prefixIcon: (icon != null)
                     ? Icon(icon, color: _text_color)
                     : null,
                 labelText: textname,
                 labelStyle: TextStyle(color: _text_color),
                 hintText: placeholder,
                 suffixText: suffixText,
                 counterText: "",
                 border: _border_type,
                 enabledBorder: _border_type,
                 focusedBorder: _focus_border_type,),
                 keyboardType: type,
                 validator: mustfill ? (value) {
                 if (value.isEmpty) {
                   return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
                 }
               }: null,

           ));
     }


  Widget text_multline(String key, String textname,String initvalue, int max_size, bool mustfill, TextAlign align) {
  _Controller[key] = new TextEditingController(text:initvalue);

  return Padding(
      padding: EdgeInsets.only(bottom: _padding),
      child: Container(
        child: new ConstrainedBox(
          constraints: BoxConstraints(
            //maxHeight: 80.0,
          ),
          child:  TextFormField(
                    textAlign: align,
                    controller: _Controller[key],
                    maxLength: max_size,
                    style: _textStyle,
                    decoration: InputDecoration(
                      contentPadding: EdgeInsets.only(left:15,top:20,bottom: (this.round == 0) ? 3 : 10 ,right: 15),
                      labelText: textname,
                      labelStyle: TextStyle(color: _text_color),
                      counterText: "",
                      border: _border_type,
                      enabledBorder: _border_type,
                      focusedBorder: _focus_border_type,

                    ),
                    keyboardType: TextInputType.multiline,

                    maxLines: null,
                    validator: (value) {
                      if (value.isEmpty && mustfill) {
                        return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
                      }
                    }

                )



        ),
      ));
}



// ignore: missing_return

  Widget email(String key, String textname,  String value, bool must_fill,TextAlign align,IconData icon) {
  _Controller[key] = new TextEditingController(text:value);

  return Padding(
      padding: EdgeInsets.only(bottom: _padding),
      child: TextFormField(
          textAlign: align,
          controller: _Controller[key],
          maxLength: 200,
          style: _textStyle,
          decoration: InputDecoration(
            contentPadding: EdgeInsets.only(left:15,top:20,bottom: (this.round == 0) ? 3 : 10 ,right: 15),
            labelText: textname,
            labelStyle: TextStyle(color: _text_color),
            counterText: "",
            border: _border_type,
            enabledBorder: _border_type,
            focusedBorder: _focus_border_type,),

          keyboardType: TextInputType.emailAddress,
          validator: (value) {

            if (value.isEmpty && must_fill) {
              return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
            }

            if(value.isNotEmpty) {
              if (!_validateEmail(value)) {
                return _PIA_TextEdit_error_email[PIA_Lang.lang_id];
              }
            }
          }
      ));
}




  Widget login(String key, String textname, TextAlign align) {
     _Controller[key] = new TextEditingController();

     return Padding(
         padding: EdgeInsets.only(bottom: _padding),
         child: TextFormField(
             textAlign: align,
             controller: _Controller[key],
             maxLength: 100,
             style: _textStyle,

             decoration: InputDecoration(

               contentPadding: EdgeInsets.only(left:15,top:20,bottom: 5,right: 15),
               prefixIcon: Icon(
                   Icons.supervised_user_circle, color: _text_color),
               labelText: textname,
               labelStyle: TextStyle(color: _text_color),
               counterText: "",

               border: _border_type,
               enabledBorder: _border_type,
               focusedBorder: _focus_border_type,),

             keyboardType: TextInputType.text,
             validator: (value) {
               if (value.isEmpty) {
                 return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
               }
             }
         ));
   }

  Widget login_password(String key, String textname,TextAlign align)
  {  _Controller[key] = new TextEditingController();

    return Padding(
      padding: EdgeInsets.only(bottom: _padding),
      child: TextFormField(
          textAlign: align,
          obscureText:true,
          controller: _Controller[key],
          maxLength: 20,
          style: _textStyle,
          decoration: InputDecoration(
            contentPadding: EdgeInsets.only(left:15,top:20,bottom: 5,right: 15),
            prefixIcon:  Icon(Icons.image_aspect_ratio, color: _text_color),
            labelText: textname,
            labelStyle: TextStyle(color: _text_color),
            counterText: "",
            border: _border_type,
            enabledBorder: _border_type,
            focusedBorder: _focus_border_type,),
            keyboardType: TextInputType.text,
            validator: (value) {
            if (value.isEmpty) {
              return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
            }
          }
      ));
  }


Widget text_password(String key, String textname,bool must_fill,TextAlign align,IconData icon) {
  _Controller[key] = new TextEditingController();

  return Padding(
      padding: EdgeInsets.only(bottom: _padding),
      child: TextFormField(
          textAlign: align,
          obscureText: true,
          controller: _Controller[key],
          maxLength: 16,
          style: _textStyle,
          decoration: InputDecoration(
            contentPadding: EdgeInsets.only(left:15,top:20,bottom: (this.round == 0) ? 3 : 10 ,right: 15),
            prefixIcon: (icon != null)
                ? Icon(icon, color: _text_color)
                : null,
            labelText: textname,
            labelStyle: TextStyle(color: _text_color),
            counterText: "",
            border: _border_type,
            enabledBorder: _border_type,
            focusedBorder: _focus_border_type,),
            keyboardType: TextInputType.text,
            validator: (value) {
            if (value.isEmpty && must_fill) {
              return _PIA_TextEdit_error_empty[PIA_Lang.lang_id];
            }

            if(value.length<8)
              {  return _PIA_TextEdit_error_password[PIA_Lang.lang_id]; }
          }
      ));
}


Widget text_chatmessage(String key, int maxlength) {
  _Controller[key] = new TextEditingController();

  return Container(
    //color:Colors.white,
    padding: EdgeInsets.only(top:5,left: 10,right: 10),
    margin: EdgeInsets.only(top:8,bottom: 5),

      decoration: new BoxDecoration(
          color: Colors.white,
          borderRadius: new BorderRadius.circular(10)),

    child: new ConstrainedBox(

      constraints: BoxConstraints(
        maxHeight: 70.0,
      ),

        child: new SingleChildScrollView(
          //scrollDirection: Axis.vertical,
          //reverse: true,
          child: new TextField(
  decoration: InputDecoration(
  contentPadding: EdgeInsets.only(top:5,bottom: 10),counterText: ""),
            style:TextStyle(height: 0.85),
            controller: _Controller[key],
            maxLength: maxlength,
            maxLines: null,

        ),
      ),
    ));
}


bool _validateEmail(String value) {
  Pattern pattern =
      r'^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$';
  RegExp regex = new RegExp(pattern);
  return regex.hasMatch(value);
}
}


// For CheckBox ------------------
class SwitchStateWidget extends StatefulWidget{

  TextEditingController controller;
  Color color;
  bool checkon;
  SwitchStateWidget({this.controller,this.color,this.checkon});

  @override
  _SwitchStateWidget_State createState() =>new _SwitchStateWidget_State();
}

class _SwitchStateWidget_State extends State<SwitchStateWidget>{
  @override
  Widget build(BuildContext context) {
    return new CupertinoSwitch(value: widget.checkon, onChanged: (bool){
      setState(() {
        widget.checkon = bool;
        widget.controller.text = bool ? "1" : "0";
      });
    },activeColor: widget.color,);
  }
}
//-------------------------------------


// For CheckBox ------------------
class CheckBoxStateWidget extends StatefulWidget{

  TextEditingController controller;
  Color color;
  bool checkon;
  CheckBoxStateWidget({this.controller,this.color,this.checkon});
  @override
  State<StatefulWidget> createState() =>new _CheckBoxState();
}

class _CheckBoxState extends State<CheckBoxStateWidget>{
  @override
  Widget build(BuildContext context) {
    return new Checkbox(value: widget.checkon, onChanged: (bool){
      setState(() {
        widget.checkon = bool;
        widget.controller.text = bool ? "1" : "0";
      });
    },activeColor: widget.color,);
  }
}
//-------------------------------------


// For CheckBox ------------------
class DatePickerWidget extends StatefulWidget{

  TextEditingController controller;
  Color text_color;
  String date_text;

  DatePickerWidget({this.controller,this.date_text,this.text_color});
  @override
  State<StatefulWidget> createState() =>new _DatePickerWidget_State();
}

class _DatePickerWidget_State extends State<DatePickerWidget>{
  @override
  Widget build(BuildContext context) {
    DateTime now = DateTime.now();

    return FlatButton(
      child:Text(widget.date_text, style:TextStyle(color:widget.text_color)),
      onPressed: () async {
        final DateTime picked = await showDatePicker(
            context: context,
             initialDate: DateTime.parse(widget.date_text),
             firstDate: DateTime(now.year,now.month),
             lastDate: DateTime(now.year + 10),
            );

        if (picked != null)
          setState(() {
            widget.date_text = "${picked.year}-" +  ((picked.month<10) ? "0" : "") + "${picked.month}-" +  ((picked.day<10) ? "0" : "") + "${picked.day}";
            widget.controller.text = widget.date_text;
          });
      },
      textColor: widget.text_color,
    );
  }
}
//-------------------------------------