import 'dart:io';
import 'package:flutter/material.dart';
import 'package:image_crop/image_crop.dart';
import 'package:pia_framework_base/Image/PIA_ImagePicker.dart';
import 'package:pia_framework_base/Lang/PIA_Lang.dart';

const Map<String, String> crop_cancel = {'1': 'Cancel', '2': '取消'};
const Map<String, String> crop_confirm= {'1': ' Confirm ', '2': ' 確定 '};
const Map<String, String> crop_title = {'1': ' Crop Photo ', '2': ' 裁剪照片 '};


class PIA_ImageCrop_Page extends StatelessWidget {
  File imagefile;
  final cropKey = GlobalKey<CropState>();
  PIA_ImagePicker_CallBack callback;
  final double maximumScale;
  final maxwidth;

  PIA_ImageCrop_Page({Key key, this.imagefile, this.callback , this.maxwidth, this.maximumScale }): super(key: key);

  @override
  Widget build(BuildContext context) {

    return Scaffold(
        appBar: AppBar(
          title: Text(crop_title[PIA_Lang.lang_id]),
        ),
        body: Container(
          color: Colors.black,
          padding: const EdgeInsets.all(10.0),
          child:
          Column(
            children: <Widget>[
              Expanded(
                child:  Crop(
                    key: cropKey,
                    image:  FileImage(imagefile),
                    maximumScale: 1,
                    alwaysShowGrid: true,
                    aspectRatio: 1,

                ),
              ),
             Row(
               mainAxisAlignment: MainAxisAlignment.spaceAround,
               children: <Widget>[
                 FlatButton(
                   child: Text(crop_confirm[PIA_Lang.lang_id],style:TextStyle(color:Colors.white,fontSize: 16),),
                   onPressed: () async {
                     print("Crop Button");
                     if(callback != null)
                       { final sampleFile = await ImageCrop.sampleImage(
                          file: imagefile,
                          preferredWidth: maxwidth,
                          preferredHeight: maxwidth );

                         final crop = cropKey.currentState;
                         final croppedFile = await ImageCrop.cropImage(
                           file: sampleFile,
                           area: crop.area,
                         );
                         callback.Image_Picker_Callback(croppedFile);
                       }
                     Navigator.pop(context);

                   },
                 ),

                 FlatButton(
                   child: Text(crop_cancel[PIA_Lang.lang_id],style:TextStyle(color:Colors.white,fontSize: 16),),
                   onPressed: (){
                     Navigator.pop(context);
                   },
                 ),

               ],
             )
            ],
          ))


    );
  }



}

