import 'dart:io' ;
import 'package:file_picker/file_picker.dart';
import 'package:flutter/material.dart';

import 'package:image_picker/image_picker.dart';
import 'package:image_crop/image_crop.dart';
import 'package:pia_framework_base/Image/PIA_ImagePicker.dart';
import 'package:pia_framework_base/Lang/PIA_Lang.dart';
import 'package:pia_framework_base/Variable/PIA_Global.dart';
import 'package:pia_framework_base/View/PIA_Page.dart';

import 'PIA_ImageCrop_Page.dart';


class PIA_ImagePicker_Crop
{
   static PIA_ImagePicker_CallBack _callback;
   static BuildContext _context;
   static bool _iscrop = false;
   static int _maxwidth = 0;


  static void show_bottom_sheet(BuildContext context,PIA_ImagePicker_CallBack callback,bool iscrop,int maxwidth,bool hasfile){
      _context = context;
      _callback = callback;
      _iscrop = iscrop;
      _maxwidth = maxwidth;

      showModalBottomSheet(
      context: context,
      builder: (BuildContext context){
        return  Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            new ListTile(
              leading: new Icon(Icons.camera),
              title: new Text(camera[PIA_Lang.lang_id]),
              onTap: () {  Navigator.pop(context); _getCamera(); }
            ),
            new ListTile(
              leading: new Icon(Icons.photo_library),
              title: new Text(photo[PIA_Lang.lang_id]),
              onTap: () {  Navigator.pop(context);  _getImage(); }
            ),
            (hasfile) ? new ListTile(
                leading: new Icon(Icons.folder_open),
                title: new Text(file[PIA_Lang.lang_id]),
                onTap: () {  Navigator.pop(context);  _getFile(); }
            ): new Container(height: 0,)
          ],
        );
      }
  );}




   static Future _getImage() async {
     final picker = ImagePicker();
    var image = await picker.getImage(source: ImageSource.gallery);
     if (_callback != null && image != null) {
          _get_image(File(image.path));
     }}

   static Future _getCamera() async {
     final picker = ImagePicker();
     var image = await picker.getImage(source: ImageSource.camera);
     if (_callback != null && image != null) {
         _get_image(File(image.path));
   }}

  static Future _getFile() async {
    FilePickerResult result = await FilePicker.platform.pickFiles();

     if (_callback != null && result != null) {
       _callback.Image_Picker_Callback(File(result.files.single.path));
    }}


   static Future _get_image(File image) async {
     print("IsCrop : " + _iscrop.toString());

     if (_iscrop) {
          var decodedImage = await decodeImageFromList(image.readAsBytesSync());
          double crop_maxvalue = (decodedImage.height * 100.0 / decodedImage.width * 100.0)/10000.0;
          print("Crop Maxvalue $crop_maxvalue");
          PIA_Page.open(_context, PIA_ImageCrop_Page(imagefile: image,callback: _callback,maxwidth:_maxwidth, maximumScale: crop_maxvalue));
     }
     else {
       if(_maxwidth > 0 ) {
         final sampleFile = await ImageCrop.sampleImage(
             file: image,
             preferredWidth: _maxwidth,
             preferredHeight: _maxwidth);
         _callback.Image_Picker_Callback(sampleFile);
       }
      else
        { _callback.Image_Picker_Callback(image); }
     }
   }




}