import 'dart:io';
import 'package:dio/src/dio_error.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:pia_framework_base/API/PIA_API_Background.dart';
import 'package:pia_framework_base/API/PIA_API_Popup_delay.dart';
import 'package:pia_framework_base/API/PIA_API_Widget.dart';
import 'package:pia_framework_base/Image/PIA_Image.dart';
import 'package:pia_framework_base/Image/PIA_ImagePicker.dart';
import 'package:pia_framework_base/Image/PIA_ImagePicker_Crop.dart';
import 'package:pia_framework_base/Variable/PIA_Global.dart';
import 'package:pia_framework_base/Form/PIA_Form.dart';


class PIA_Chatroom_CallBack
{    Widget Chat_item(BuildContext context,Map<String,dynamic> sdata) {} }

// example for callback
// return new Padding(padding: EdgeInsets.all(0),
//      child: new ListTile(
//      //leading: PIA_Image("Asset/Image/company.png",50,50,0,BoxFit.cover),
//      title: new Text(sdata["api"],style:new TextStyle(color: (sdata["isclick"] == "1" ) ? Colors.blue : Colors.pink)),
//      subtitle: (sdata["isclick"] == "1") ? PIA_Image("Asset/Image/company.png",150,150,0,BoxFit.cover): null,
//          onTap: (){
//        if(sdata["isclick"] != "1")
//          {  sdata["isclick"] = "1"; }
//         else
//          {  sdata["isclick"] = ""; }
//
//        updatestate(null);
//      },
//    ));

class PIA_Chatroom_Controller {
  _PIA_Chatroom_State State;
  update() {
    State.sound = true;
    State.Update();
  }
}

class PIA_Chatroom extends StatefulWidget
{   String chat_url;
String Send_message_url;
String Send_Photo_url;
bool hasfile = false;

Map<String,String> post = Map<String,String>();
PIA_Chatroom_CallBack callback;
PIA_Chatroom_Controller controller;

PIA_Chatroom({this.chat_url,this.Send_message_url,this.Send_Photo_url, this.post, this.callback,this.controller,this.hasfile});
_PIA_Chatroom_State createState()
{ print("Create Chat State");
return _PIA_Chatroom_State(); }
}


// #docregion print-state
class _PIA_Chatroom_State extends State<PIA_Chatroom> implements PIA_API_CallBack, PIA_ImagePicker_CallBack{
  ScrollController _controller;
  bool firstload = true;
  PIA_Form form = PIA_Form(TextStyle(fontSize: 12), Colors.black26, 5);
  String last_id = "0";
  BuildContext _context;
  bool update_data = false;
  bool sound = false;

  final items = new List<Map<String,dynamic>>();

  void initState() {
    _controller = ScrollController();
    widget.controller.State = this;

    if(widget.post == null)
    { print("Set Widget post ");
    widget.post = Map<String,String>(); }
  }


  @override
  Widget build(BuildContext context) {
    print("PIA_Chatroom Build Now");
    print(widget.chat_url + " : Post : " + widget.post.toString());


    _context = context;
    if (firstload) {
      return PIA_API_Widget(url:widget.chat_url,post:widget.post,callback:this);
    }
    else
    {  return Column(
      children: <Widget>[
        Expanded(child:Chat_Body(context)),
        Divider(height: 1,color: Colors.black26,),
        Container(
          color: Colors.grey.withOpacity(0.1),
          child:Default_input(context),
        )
      ],
    );
    }
  }

  Widget Chat_Body(BuildContext context) {
    return GestureDetector(
      child: ListView.builder(itemCount: items.length,
          padding: EdgeInsets.all(10.0),
          controller: _controller,
          reverse: true,
          itemBuilder: (context, index) {
            if (widget.callback != null) {
              return widget.callback.Chat_item(context,items[index]);
            }
            else {
              return Default_item(context,items[index]);
            }
          }),
      onTap: (){ print("Tap "); FocusScope.of(context).requestFocus(FocusNode());},
      onTapDown: (TapDownDetails details)  { print("Tap Down"); FocusScope.of(context).requestFocus(FocusNode());},
    );
  }


  Widget Default_input(BuildContext context)
  {  return Row(
    crossAxisAlignment: CrossAxisAlignment.start,
    children: <Widget>[
      Padding(
        padding: const EdgeInsets.only(top:3.0),
        child: IconButton(icon: Icon(Icons.attach_file),onPressed: () { Get_photo(context);}),
      ),
      Expanded(child:form.text_chatmessage("message",500)),
      Padding(
        padding: const EdgeInsets.only(top:3.0),
        child: IconButton(icon: Icon(Icons.send),onPressed:(){ Send_Message();}),
      ),
    ],
  );
  }


  Widget Default_item(BuildContext context,Map<String,dynamic> json)
  {  if(json["type"] == 1)
  {  return Padding(
      padding: EdgeInsets.all(10),
      child:
      Column(
        crossAxisAlignment: CrossAxisAlignment.end,
        children: <Widget>[
          (json["photo"].toString().isEmpty) ?
          ClipRRect(
              borderRadius: BorderRadius.circular(10.0),
              child: Container(
                padding: EdgeInsets.all(10.0),
                child:Column(
                  children: <Widget>[
                    Text(json["message"].toString(),style: TextStyle(color:Colors.black),),
                    Text(json["time"]),
                  ],
                ),
                color: Colors.grey,
                constraints: BoxConstraints(
                  maxWidth: 300,
                ),
              ))
              :
          GestureDetector(
              onTap: () {
                //PIA_Page.new_page(context, PIA_WebPage(title:lang_photo[PIA_Lang.lang_id],url:json["photo"].toString()));
                //PIA_Page.open(context,PIA_PhotoView(url:json["photo"].toString()));
              },
              child: PIA_Image(json["photo"].toString(),200,200,10,BoxFit.cover)
          ),


        ],
      )
  );

  }
  else
  {
    return Padding(
        padding: EdgeInsets.all(10),
        child:
        Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            (json["photo"].toString().isEmpty) ?
            ClipRRect(
                borderRadius: BorderRadius.circular(10.0),
                child: Container(
                  padding: EdgeInsets.all(10.0),

                  child:Column(
                    children: <Widget>[
                      //Text(json["message"].toString(),style: TextStyle(color:Colors.white),),
                      //Text(json["time"],style: TextStyle(color:Colors.grey),textAlign: TextAlign.right,),
                    ],
                  ),
                  color: Colors.blueAccent,
                  constraints: BoxConstraints(
                    maxWidth: 300,
                  ),
                ))
                :
            GestureDetector(
                onTap: () {
                  //PIA_Page.new_page(context, PIA_WebPage(title:lang_photo[PIA_Lang.lang_id],url:json["photo"].toString()));
                  //PIA_Page.open(context,PIA_PhotoView(url:json["photo"].toString()));
                },
                child: PIA_Image(json["photo"].toString(),200,200,10,BoxFit.cover)
            ),


          ],
        )
    );

  }
  }

  void Update()
  { widget.post["last_id"] = last_id;
    PIA_API_Background.Post(widget.chat_url,widget.post,this);

  }

  void Get_photo(BuildContext context)
  {  print("Get Photo");
  //PIA_ImageFilePicker.show_bottom_sheet(context,this,1000);
  PIA_ImagePicker_Crop.show_bottom_sheet(context, this, false, 1000, widget.hasfile);
  }

  void Send_Message() {
    print("Send Message");
    FocusScope.of(context).unfocus();
    sound = false;
    widget.post["message"] = form.get("message").toString();
    widget.post["last_id"] = last_id;
    PIA_API_Popup_Delay.Post(_context, widget.Send_message_url,widget.post,this);
  }

  @override
  void API_Error(DioErrorType error) {
    print("API Error");
    // TODO: implement API_Error
  }

  @override
  void API_Success(Map<String, dynamic > json, List j) {
    print("Load Success last_id ${json['last_id']}");
    firstload = false;

    if(last_id == json["last_id"])
    {  if(last_id == "0")
    {  setState(() {}); }
    return;
    }

    last_id = json["last_id"];

    this.setState(() {
      print("Set State");
      j.forEach((dynamic value) {
        items.insert(0, value);
      });
    });
    _controller.animateTo(0.0, duration: Duration(milliseconds: 300), curve: Curves.easeOut);
    if(sound)
    { SystemSound.play(SystemSoundType.click); }
    sound = false;
  }

  @override
  void API_Upload_prodcess(int upload, int total) {
    // TODO: implement API_Upload_prodcess
  }

  @override
  void Image_Picker_Callback(File image) {
    // TODO: implement Image_Picker_Callback
    sound = false;
    widget.post["last_id"] = last_id;
    PIA_API_Popup_Delay.Upload(_context, widget.Send_Photo_url,widget.post,{"photo":image},this);
  }


}



