import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:overlay_support/overlay_support.dart';
import 'package:pia_framework_base/Variable/PIA_Global.dart';
import 'package:pia_framework_base/Lang/PIA_Lang.dart';



//user PIA_Alert example
//var action = await PIA_Alert.twobutton(context, "Title","message", "OK", "Cancel", true);
// if action == AlertButton.button1 {...,},

enum PIA_Alert_Button { None,Button1,Button2,Ok,Confirm ,Yes,No}

class PIA_Alert
{

 static void Error(BuildContext context,String title,String message)
  { showDialog<String>(
    context: context,
    barrierDismissible: true,
    builder: (BuildContext context) {
      var dialog = new CupertinoAlertDialog (
        //title: new Text(title,style:TextStyle(color:Colors.red,fontSize: 16)),
        title: new Icon(Icons.highlight_off,color: Colors.red,size: 50,),
        content: new Text(message),
        actions: <Widget>[
          CupertinoDialogAction(isDefaultAction: true,
            child: Text(lang_close[PIA_Lang.lang_id]),
            onPressed: () {
              Navigator.pop(context);
              print("Dio Clear");
            },
          )
        ],
      );
      return dialog;
     }
    );
  }

   static Future<PIA_Alert_Button> Success(BuildContext context,String message)
   async {  final action = await showDialog(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog =   WillPopScope(
             onWillPop: () { print("Back Press");},

         child: CupertinoAlertDialog (
           title: new Icon(Icons.check_circle_outline,color: Colors.green,size: 50,),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(lang_ok[PIA_Lang.lang_id]),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Ok),
             ),
           ],
         ));
         return dialog;
       }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
   }


 static Future<PIA_Alert_Button> Onebutton(BuildContext context,String title,String message,String button_name)
 async {  final action = await showDialog(
    context: context,
    barrierDismissible: false,
    builder: (BuildContext context) {
      var dialog =  WillPopScope(
          onWillPop: () { print("Back Press");},
          child: CupertinoAlertDialog (
        title: new Text(title,style:TextStyle(fontSize: 16)),
        content: new Text(message),
        actions: <Widget>[
          CupertinoDialogAction(isDefaultAction: true,
            child: Text(button_name),
            onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Button1),
          )
        ],
      ));
      return dialog;
    }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
}


  static Future<PIA_Alert_Button> Twobutton(BuildContext context,String title,String message,String button_name1,String button_name2)
  async {  final action = await showDialog(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog = WillPopScope(
             onWillPop: () { print("Back Press");},
           child:CupertinoAlertDialog (
           title: new Text(title,style:TextStyle(fontSize: 16)),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(button_name1),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Button1),
             ),
             CupertinoDialogAction(
               child: Text(button_name2,style:TextStyle(color:Colors.grey)),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Button2),
             )
           ],
         ));
         return dialog;
       }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
   }

  static Future<PIA_Alert_Button> Confirm(BuildContext context,String title,String message)
   async {  final action = await showDialog(
       context: context,
       barrierDismissible: true,
       builder: (BuildContext context) {
         var dialog = new CupertinoAlertDialog (
           title: new Text(title,style:TextStyle(fontSize: 16)),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(lang_confirm[PIA_Lang.lang_id]),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Confirm),
             ),
             CupertinoDialogAction(
               child: Text(lang_cancel[PIA_Lang.lang_id],style:TextStyle(color:Colors.grey)),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.None),
             )
           ],
         );
         return dialog;
       }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
   }

   static Future<PIA_Alert_Button> Ok(BuildContext context,String title,String message)
   async {  final action = await showDialog(
       context: context,
       barrierDismissible: true,
       builder: (BuildContext context) {
         var dialog = new CupertinoAlertDialog (
           title: new Text(title,style:TextStyle(fontSize: 16)),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(lang_yes[PIA_Lang.lang_id]),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Ok),
             ),
             CupertinoDialogAction(
               child: Text(lang_cancel[PIA_Lang.lang_id],style:TextStyle(color:Colors.grey)),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.None),
             )
           ],
         );
         return dialog;
       }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
   }

   static Future<PIA_Alert_Button> YesNo(BuildContext context,String title,String message)
   async {  final action = await showDialog(
       context: context,
       barrierDismissible: true,
       builder: (BuildContext context) {
         var dialog = new CupertinoAlertDialog (
           title: new Text(title,style:TextStyle(fontSize: 16)),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(lang_yes[PIA_Lang.lang_id]),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.Yes),
             ),
             CupertinoDialogAction(
               child: Text(lang_no[PIA_Lang.lang_id],style:TextStyle(color:Colors.grey)),
               onPressed: () => Navigator.of(context).pop(PIA_Alert_Button.No),
             )
           ],
         );
         return dialog;
       }
   );
   return (action != null) ? action : PIA_Alert_Button.None;
   }

}